%global commit0 00a0e5bae2c03b9b824b6e22341525ef7ee0a91c
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

%global gh_owner brutasse
%global gh_project graphite-api

Name:           graphite-api
Version:        1.1.3
Release:        11%{?dist}
Summary:        Graphite-web, without the interface. Just the rendering HTTP API

License:        ASL 2.0
URL:            https://github.com/brutasse/graphite-api
Source0:        https://github.com/%{gh_owner}/%{gh_project}/archive/%{commit0}/%{gh_project}-%{commit0}.tar.gz
Source1:        graphite-api.yaml
Source2:        graphite-api.sysconfig
Source3:        graphite-api.service

BuildArch:      noarch

BuildRequires:  systemd
Requires(pre):  shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

# epel7 is missing python3 packages, build with python3 on Fedora and with
# python2 on epel7
%if 0%{?fedora}
BuildRequires:  python3-cairo
BuildRequires:  python3-cairocffi
BuildRequires:  python3-devel
BuildRequires:  python3-flask
BuildRequires:  python3-flask-cache
BuildRequires:  python3-mock
BuildRequires:  python3-pyparsing
BuildRequires:  python3-pytest
BuildRequires:  python3-pytz
BuildRequires:  python3-PyYAML
BuildRequires:  python3-setuptools
BuildRequires:  python3-structlog
BuildRequires:  python3-six
BuildRequires:  python3-tzlocal
Requires:       python3-pyparsing
Requires:       python3-cairo
Requires:       python3-cairocffi
Requires:       python3-flask
Requires:       python3-flask-cache
Requires:       python3-gunicorn
Requires:       python3-structlog
Requires:       python3-six
Requires:       python3-statsd
Requires:       python3-tzlocal
Requires:       python3-pytz
Requires:       python3-PyYAML
%else
BuildRequires:  pyparsing
BuildRequires:  pytest
BuildRequires:  python-cairocffi
BuildRequires:  python-flask
BuildRequires:  python-setuptools
BuildRequires:  python-structlog
BuildRequires:  python-six
BuildRequires:  python-tzlocal
BuildRequires:  python2-devel
BuildRequires:  python2-mock
BuildRequires:  pytz
BuildRequires:  PyYAML
Requires:       pyparsing
Requires:       python-cairocffi
Requires:       python-flask
Requires:       python-flask-cache
Requires:       python-gunicorn
Requires:       python-structlog
Requires:       python-six
Requires:       python-tzlocal
Requires:       python2-statsd
Requires:       pytz
Requires:       PyYAML
%endif


%description
Graphite-API is an alternative to Graphite-web, without any built-in dashboard.
Its role is solely to fetch metrics from a time-series database (whisper,
cyanite, etc.) and rendering graphs or JSON data out of these time series. It
is meant to be consumed by any of the numerous Graphite dashboard applications.


%if 0%{?fedora}
%package doc
Summary:        Documentation for graphite-api
License:        ASL 2.0

BuildRequires:  python3-sphinx
BuildRequires:  python3-sphinx_rtd_theme


%description doc
Documentation for graphite-api
%endif


%prep
%autosetup -n %{gh_project}-%{commit0}

%if 0%{?fedora} == 0
sed -i 's|^ExecStart=/usr/bin/python3-gunicorn |ExecStart=/usr/bin/gunicorn |' %{SOURCE3}
%endif


%build
%if 0%{?fedora}
%py3_build
pushd docs
sphinx-build-3 -b html -d build/doctrees . build/html
rm -f build/html/.buildinfo
sed -i 's/\r$//' build/html/_static/jquery.js
popd
%else
%py2_build
%endif


%install
%if 0%{?fedora}
%py3_install
%else
%py2_install
%endif

install -Dp -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/graphite-api.yaml
install -Dp -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -Dp -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service

mkdir -p %{buildroot}%{_sharedstatedir}/graphite-api


%check
%if 0%{?fedora}
py.test-3 tests
%else
py.test tests
%endif


%pre
getent group graphite-api >/dev/null || groupadd -r graphite-api
getent passwd graphite-api >/dev/null || \
    useradd -r -g graphite-api -d / -s /sbin/nologin \
    -c "graphite-api daemon user" graphite-api
exit 0


%post
%systemd_post %{name}.service


%preun
%systemd_preun %{name}.service


%postun
%systemd_postun_with_restart %{name}.service


%files
%doc README.rst CONTRIBUTING.md
%license LICENSE
%config(noreplace) %{_sysconfdir}/graphite-api.yaml
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0755,graphite-api,graphite-api) %dir %{_sharedstatedir}/graphite-api
%{_unitdir}/%{name}.service

%if 0%{?fedora}
%{python3_sitelib}/graphite_api*
%else
%{python2_sitelib}/graphite_api*
%endif


%if 0%{?fedora}
%files doc
%doc docs/*.rst docs/build/html
%license LICENSE
%endif


%changelog
* Fri Nov 02 2018 Piotr Popieluch <piotr1212@gmail.com> - 1.1.3-11
- Fix unit file to have the correct path to the Gunicorn binary

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 1.1.3-9
- Rebuilt for Python 3.7

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 1.1.3-8
- Rebuilt for Python 3.7

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com> - 1.1.3-4
- Rebuild for Python 3.6

* Tue Aug 09 2016 Piotr Popieluch <piotr1212@gmail.com> - - 1.1.3-3
- Add python2 support for epel7
- Set correct sharedstatedir ownership
- Add Requires: statsd
- Improve example configuration
- Remove redundant Requires:
- Update to use pyX macros for building and installing

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.3-2
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Thu May 26 2016 Piotr Popieluch <piotr1212@gmail.com> - 1.1.3-1
- Update to 1.1.3

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Nov 22 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.2-1
- Update to 1.1.2

* Wed Nov 11 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.1-4
- Update test to support python 3.5

* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Fri Nov 06 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.1-2
- Rebuilt for Python 3.5

* Wed Oct 28 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.1-1
- Update to new version

* Tue Oct 13 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1-1
- Update to 1.1

* Sat Sep 26 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.0.1-5.20150926git4cb65cd
- remove system executalbe macros
- update to newer version
- add license to doc package

* Wed Jul 22 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.0.1-4.20150702gitbe7907c
- remove epel and python2 support
- fix lint warnings

* Thu Jul 02 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.0.1-3.20150702gitbe7907c
- update to github master head
- moved license to %%license
- fix buildrequires

* Wed Oct 22 2014 Piotr Popieluch <piotr1212@gmail.com> - 1.0.1-2
- added %%check
- patch for timezone issue and to pass the %%check
- made python version explicit

* Sat Oct 11 2014 Piotr Popieluch <piotr1212@gmail.com> - 1.0.1-1
- Initial package

